package com.vcs.devplugin.vcs_general_plugin;

import android.content.Context;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;

import androidx.annotation.NonNull;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;

/**
 * VcsGeneralPlugin
 */
public class VcsGeneralPlugin implements FlutterPlugin, MethodCallHandler {
    /// The MethodChannel that will the communication between Flutter and native Android
    ///
    /// This local reference serves to register the plugin with the Flutter Engine and unregister it
    /// when the Flutter Engine is detached from the Activity
    private MethodChannel channel;
    private Context context;

    @Override
    public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
        channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "vcs_general_plugin");
        context = flutterPluginBinding.getApplicationContext();
        channel.setMethodCallHandler(this);
    }

    @Override
    public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
        if (call.method.equals("getPlatformVersion")) {
            result.success("Android " + android.os.Build.VERSION.RELEASE);
        }else if (call.method.equals("getKey")) {
            result.success("B4V2A1C@S#S$F");
        } else if (call.method.equals("checkInternet")) {
            //result.success("Android " + android.os.Build.VERSION.RELEASE);
            boolean isNet = isNetworkConnected(context);
            if (isNet) result.success("true");
            else result.success("false");
        } else if (call.method.equals("getUniqueNumber")) {
            //result.success("Android " + android.os.Build.VERSION.RELEASE);
            try {
                String encStr = encriptionDetails.getUniqueNumber(context);
                result.success(encStr);
            } catch (Exception e) {
                e.printStackTrace();
                result.error("UNAVAILABLE", "-" + e.getMessage(), null);
            }
        } else if (call.method.equals("encodeData")) {
            //result.success("Android " + android.os.Build.VERSION.RELEASE);
            if (call.hasArgument("details") && call.hasArgument("key")) {
                String details = call.argument("details");
                String key = call.argument("key");
                try {

                    try {
                        String encStr;
                        if (key != null) {
                            encStr = encriptionDetails.Encrypt(details, key);
                            result.success(encStr);
                        }

                    } catch (Exception e) {
                        e.printStackTrace();
                        result.error("UNAVAILABLE", "-" + e.getMessage(), null);
                    }


                } catch (Exception e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                    result.success("error:" + e.getMessage());
                }

            } else {
                result.error("UNAVAILABLE", "perameters not found", null);
            }
        } else if (call.method.equals("decodeData")) {
            //result.success("Android " + android.os.Build.VERSION.RELEASE);
            if (call.hasArgument("details") && call.hasArgument("key")) {
                String details = call.argument("details");
                String key = call.argument("key");

                try {
                    assert key != null;
                    String encStr = encriptionDetails.Decrypt(details, key);
                    result.success(encStr);
                } catch (Exception e) {
                    e.printStackTrace();
                    result.error("UNAVAILABLE", "-" + e.getMessage(), null);
                }

            } else {
                result.error("UNAVAILABLE", "perameters not found", null);
            }
        } else if (call.method.equals("RE_Encryption")) {
            //result.success("Android " + android.os.Build.VERSION.RELEASE);
            if (call.hasArgument("details") && call.hasArgument("key")) {
                String details = call.argument("details");
                String key = call.argument("key");
                try {

                    try {
                        String encStr;
                        if (key != null) {
                            encStr = AesCipher.encrypt(details, key);
                            result.success(encStr);
                        }

                    } catch (Exception e) {
                        e.printStackTrace();
                        result.error("UNAVAILABLE", "-" + e.getMessage(), null);
                    }


                } catch (Exception e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                    result.success("error:" + e.getMessage());
                }

            } else {
                result.error("UNAVAILABLE", "perameters not found", null);
            }
        } else if (call.method.equals("RE_Description")) {
            //result.success("Android " + android.os.Build.VERSION.RELEASE);
            if (call.hasArgument("details") && call.hasArgument("key")) {
                String details = call.argument("details");
                String key = call.argument("key");
                try {

                    try {
                        String encStr;
                        if (key != null) {
                            encStr = AesCipher.decrypt(details, key);
                            result.success(encStr);
                        }

                    } catch (Exception e) {
                        e.printStackTrace();
                        result.error("UNAVAILABLE", "-" + e.getMessage(), null);
                    }


                } catch (Exception e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                    result.success("error:" + e.getMessage());
                }

            } else {
                result.error("UNAVAILABLE", "perameters not found", null);
            }
        } else {
            result.notImplemented();
        }
    }

    @Override
    public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
        channel.setMethodCallHandler(null);
    }

    private boolean isNetworkConnected(Context context) {
        ConnectivityManager cm =
                (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo activeNetwork = cm.getActiveNetworkInfo();
        return activeNetwork != null &&
                activeNetwork.isConnectedOrConnecting();
    }
}
