import Flutter
import UIKit
import Foundation
import SystemConfiguration
import CommonCrypto // FOR RE ENCRYPT
import CryptoSwift

public class SwiftVcsGeneralPlugin: NSObject, FlutterPlugin {
    
    var dict : Dictionary = Dictionary<String,String>()
    
    public static func register(with registrar: FlutterPluginRegistrar) {
        let channel = FlutterMethodChannel(name: "vcs_general_plugin", binaryMessenger: registrar.messenger())
        let instance = SwiftVcsGeneralPlugin()
        registrar.addMethodCallDelegate(instance, channel: channel)
    }
    
    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        
        //let arguments = call.arguments
        let args = call.arguments as? Dictionary<String, String>
        
        if(call.method == "getUniqueNumber"){
            let retValue = getDeviceUniqueNo()
            result(retValue)
        }else if(call.method == "getKey"){
            //let retValue = getDeviceUniqueNo()
            result("B4V2A1C@S#S$F")
        }else if(call.method == "checkInternet"){
            let result1 = Reachability.isConnectedToNetwork()
            if(result1){
                //print("true")
                result("true")
            }else{
                //print("false")
                result("false")
            }
            //result(result1)
        }else if(call.method == "encodeData"){
            //let details : String = dict["details"] ?? ""
            //let key : String = dict["key"] ?? ""
            //let iv : String = dict["iv"] ?? ""
            
            let details = args?["details"]
            let key = args?["key"]
            let iv = args?["iv"]
            
            //let details = arguments["details"]//
            //let key = arguments["key"]
            //let iv = arguments["iv"]
                
            print("dict:\(dict)")
            print("details:\(details!)")
            print("key:\(key!)")
            print("iv:\(iv!)")
            
            /*let key = "B4V2A1C@S#S$F"
             let iv = "0000000000000000"
             let details = "Vcs@1234"*/
            let enc = try! details!.aesEncrypt1(key: key!, iv: iv!)
            //print(enc)
            result(enc)
            
            
        }else if(call.method == "decodeData"){
            /*let details : String = dict["details"] ?? ""
            let key : String = dict["key"] ?? ""
            let iv : String = dict["iv"] ?? ""*/
            
            let details = args?["details"]
            let key = args?["key"]
            let iv = args?["iv"]
            
            print("details:\(details!)")
            print("key:\(key!)")
            print("iv:\(iv!)")
            
            do{
                let dec = try details!.aesDecrypt1(key: key!, iv: iv!)
                //print("dec:\(dec)")
                //print("\(details == dec)")
                result(dec)
            }catch let error {
                //print("error:\(error)")
                result("error:\(error)")
            }
            
        }else{
            result("iOS " + UIDevice.current.systemVersion)
        }
    }
    
    func getDeviceUniqueNo()->String{
        let udifstr = UIDevice.current.identifierForVendor!.uuidString
        let mili:Int64 = getCurrentMillis()
        let rand:Int64 = getRandomNumber()
        let iint:Int = "\(mili)".count
        let iii = udifstr + "\(mili)" +  "\(iint)" + "\(rand)";
        //print(iii)
        return iii
    }
    
    func getCurrentMillis()->Int64 {
        return Int64(Date().timeIntervalSince1970 * 1000)
    }
    
    func getRandomNumber()->Int64 {
        let number = floor(Double(arc4random_uniform(1000) * 6000)) + 1000
        return Int64(number)
    }
    
    
}


extension String {
    
    func aesEncrypt1(key: String, iv: String) throws -> String {
        
        print("###########")
        print("key:\(key)")
        print("iv:\(iv)")
        print("###########")
        
        let pwdBytes = [UInt8](key.utf8)
        var keyBytes: [UInt8] = Array(arrayLiteral: 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
        var len = pwdBytes.count
        if(len > keyBytes.count){
            len = keyBytes.count
            //keyBytes = NSArray(array:b, copyItems: true) as! [UInt8]
        }
        
        var i:Int = 0
        while(i < len){
            keyBytes[i] = pwdBytes[i]
            i = i + 1
        }
        
        let key1 = keyBytes
        let iv1 = keyBytes
        
        //let encrypted = try AES(key: key1, iv: iv1, blockMode:.CBC, padding: .pkcs5).encrypt([UInt8](self.data(using: .utf8)!))
        
        let encrypted = try AES(key: [UInt8](key1), blockMode: CBC(iv: [UInt8](iv1)), padding: .pkcs7).encrypt([UInt8](self.data(using: .utf8)!))
        
        return Data(encrypted).base64EncodedString()
    }
    
    func aesDecrypt1(key: String, iv: String) throws -> String {
        
        let pwdBytes = [UInt8](key.utf8)
        var keyBytes: [UInt8] = Array(arrayLiteral: 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
        var len = pwdBytes.count
        if(len > keyBytes.count){
            len = keyBytes.count
            //keyBytes = NSArray(array:b, copyItems: true) as! [UInt8]
        }
        
        var i:Int = 0
        while(i < len){
            keyBytes[i] = pwdBytes[i]
            i = i + 1
        }
        
        let key1 = keyBytes
        let iv1 = keyBytes
        
        guard let data = Data(base64Encoded: self) else { return "" }
        let decrypted = try AES(key: [UInt8](key1), blockMode: CBC(iv: [UInt8](iv1)), padding: .pkcs5).decrypt([UInt8](data))
        //let decrypted = try AES(key: key1, iv: iv1, blockMode:.CBC, padding: .pkcs5).decrypt([UInt8](data))
        return String(bytes: Data(decrypted).bytes, encoding: .utf8) ?? "Could not decrypt"
    }
}

public class Reachability {
    
    class func isConnectedToNetwork() -> Bool {
        
        var zeroAddress = sockaddr_in(sin_len: 0, sin_family: 0, sin_port: 0, sin_addr: in_addr(s_addr: 0), sin_zero: (0, 0, 0, 0, 0, 0, 0, 0))
        zeroAddress.sin_len = UInt8(MemoryLayout.size(ofValue: zeroAddress))
        zeroAddress.sin_family = sa_family_t(AF_INET)
        
        let defaultRouteReachability = withUnsafePointer(to: &zeroAddress) {
            $0.withMemoryRebound(to: sockaddr.self, capacity: 1) {zeroSockAddress in
                SCNetworkReachabilityCreateWithAddress(nil, zeroSockAddress)
            }
        }
        
        var flags: SCNetworkReachabilityFlags = SCNetworkReachabilityFlags(rawValue: 0)
        if SCNetworkReachabilityGetFlags(defaultRouteReachability!, &flags) == false {
            return false
        }
        
        /* Only Working for WIFI
         let isReachable = flags == .reachable
         let needsConnection = flags == .connectionRequired
         
         return isReachable && !needsConnection
         */
        
        // Working for Cellular and WIFI
        let isReachable = (flags.rawValue & UInt32(kSCNetworkFlagsReachable)) != 0
        let needsConnection = (flags.rawValue & UInt32(kSCNetworkFlagsConnectionRequired)) != 0
        let ret = (isReachable && !needsConnection)
        
        return ret
        
    }
}
